; Alternativer 2WB-Treiber 
; CCTools 9.8.2002 (cctools.hs-control.de)
; Es werden nurnoch 5 anstatt 9 Bytes Userram
; bentigt:
; Byte[1] = Data0
; Byte[2] = Data1
; Byte[3] = Data2
; Byte[4] = TXadr
; Byte[5] = RXadr
; stack   = ID     

; $91 = CRC2               
; $92 = Data0  
; $93 = Data1 
; $94 = Data2 
; $95 = CRC1               
; $96 = TXADR 
; $97 = RXADR 
; $98 = ID
; $9a = Temp
; sys 2WB, Data0,Data1,Data2,TXADR,RXADR,ID  
; returns: ID  = $92(error=0) (get via pop)

port    equ $01 ; Port B
DIR     equ $05 ; PortBdir
CLK     equ 6
DTA     equ 7

Temp    equ $9a
Data    equ $91
D0      equ $a1
D1      equ $a2
D2      equ $a3
TX      equ $a4
RX      equ $a5
ID      equ $92 ; ID wird ber Stack ber-und zurckgegeben


       org $101
       lda $92 
       sta $98 ;ID
       lda D0
       sta $92 ;Data0
       lda D1 
       sta $93 ;Data1
       lda D2 
       sta $94 ;Data2
       lda TX
       sta $96 ;TXADR
       lda RX
       sta $97 ;RXADR
       clr $91 ;CRC2=0
       clr $95 ;CRC1=0
       sei             
       bset CLK,DIR    
       bset CLK,port   
       bset DTA,DIR    
       ldx #$20
Loop1  decx       ;sleep ?
       bne Loop1
nextbyte
       lda #$08
       sta Temp
nextbit
       lda #$05
Loop2  deca       ;sleep ?
       bne Loop2
       bset CLK,port
       rol Data,x  
       bset DTA,port
       blo Next     
       bclr DTA,port
Next   bclr CLK,port
       dec Temp
       bne nextbit 
       incx
       cmpx #$08
       bne nextbyte       ;next byte ; firstbyte first (1 to 8)
       bclr DTA,DIR       ;DTA as input
       bclr CLK,DIR       ;CLK as input
       clrx 
;Daten empfangen:
waitlow        ;Warten bis CLK-Ltg. auf Low(Modem=Master)
       brclr CLK,port,waitlow
recnbyte
       lda #$08
       sta Temp
recnbit
       clra
Loop3  deca
       beq done
       brclr CLK,port,Loop3
waitlow2
       brset CLK,port,waitlow2
       lda port
       lsla
       rol Data,x
       dec Temp
       bne recnbit
       incx
       cmpx #$08
       bne recnbyte
done   cli
       lda $97 
       sta RX  ;RXADR
       lda $96 
       sta TX  ;TXADR
       lda $94 
       sta D2  ;Data2
       lda $93 
       sta D1  ;Data1
       lda $92 
       sta D0  ;Data0
       lda $98 
       sta $92 ;ID
       clr $91
       rts
